<?php

namespace App\Admin;

use Sonata\AdminBundle\Admin\AbstractAdmin;
use Sonata\AdminBundle\Datagrid\DatagridMapper;
use Sonata\AdminBundle\Datagrid\ProxyQueryInterface;
use Sonata\AdminBundle\Datagrid\ListMapper;
use Sonata\AdminBundle\Show\ShowMapper;

class VentasAdmin extends AbstractAdmin
{

    protected function configureQuery(ProxyQueryInterface $query): ProxyQueryInterface
    {

        $query->orderBy($query->getRootAlias() . '.id', 'DESC');

        return $query;
    }

    protected function configureDatagridFilters(DatagridMapper $filter): void
    {
        $filter
            ->add('mes')
            ->add('year', null, [
                'label' => 'Año',
            ])
            ;
    }

    protected function configureListFields(ListMapper $listMapper): void
    {
        $listMapper
            ->add('mes')
            ->add('year', null, [
                'label' => 'Año',
            ])
            ->add('completados', null, [
                'label' => 'Pedidos terminados',
            ])
            ->add('cancelados', null, [
                'label' => 'Pedidos cancelados',
            ])
            ->add('total', null, [
                'label' => 'Total vendido',
            ])
            ->add('_action', 'actions', [
                'actions' => [
                    'show' => [],
                ],
                'label' => 'Acciones',
            ]);
    }

    protected function configureShowFields(ShowMapper $showMapper): void
    {
        $showMapper
            ->add('mes')
            ->add('year', null, [
                'label' => 'Año',
            ])
            ->add('completados', null, [
                'label' => 'Pedidos terminados',
            ])
            ->add('cancelados', null, [
                'label' => 'Pedidos cancelados',
            ])
            ->add('total', null, [
                'label' => 'Total vendido',
            ]);
    }
}