<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Doctrine\Persistence\ManagerRegistry as PersistanceManagerRegistry;
use Dompdf\Dompdf;
use Dompdf\Options;
use App\Entity\Pedido;

class PedidosController extends AbstractController
{
    public function printPedido(PersistanceManagerRegistry $doctrine): Response
    {
        $em = $doctrine->getManager();
        $pedidoId = $_GET['id'];

        $pedido = $em->getRepository('App\Entity\Pedidos')->findOneBy(['id' => $pedidoId]);

        return $this->render('admin/plantilla_pedido.html.twig', [
            'pedido' => $pedido,
        ]);
    }

    public function generatePedidoPdf(PersistanceManagerRegistry $doctrine)
    {
        // Obtener datos del pedido
        $em = $doctrine->getManager();
        $pedidoId = $_GET['id'];
        $pedido = $em->getRepository('App\Entity\Pedidos')->findOneBy(['id' => $pedidoId]);

        // configurar e iniciar el Dompdf
        $options = new Options();
        $options->set('defaultFont', 'Arial');
        $dompdf = new Dompdf($options);

        // Obtener el HTML
        $html = $this->renderView('admin/plantilla_pedido.html.twig', [
            'pedido' => $pedido,
        ]);

        // Cargar el HTML al Dompdf y asignar tamaño y horientación
        $dompdf->loadHtml($html);
        $dompdf->setPaper('A4', 'portrait');

        // Renderizar el documento
        $dompdf->render();

        // Enviar el PDF generado al navegador para descargar
        $output = $dompdf->output();
        $response = new Response($output);
        $response->headers->set('Content-Type', 'application/pdf');
        $response->headers->set('Content-Disposition', 'attachment;filename="pedido.pdf"');

        return $response;

    }
}