<?php

namespace App\Entity;

use App\Repository\CatalogosRepository;
use Doctrine\ORM\Mapping as ORM;
use Gedmo\Timestampable\Traits\TimestampableEntity;

/**
 * @ORM\Entity(repositoryClass=CatalogosRepository::class)
 */
class Catalogos
{
    use TimestampableEntity;

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $nombre;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $descripcion;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Fabricantes", inversedBy="catalogos")
     * @ORM\JoinColumn(nullable=false)
     */
    private $fabricante;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $precio;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $medidas;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\SonataMediaMedia", cascade={"persist", "remove"})
     */
    private $pdf;

    /**
     * @ORM\Column(type="boolean")
     */
    private $activo;


    public function __toString()
    {
        return $this->nombre ?? 'Catalogo';
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNombre(): ?string
    {
        return $this->nombre;
    }

    public function setNombre(string $nombre): self
    {
        $this->nombre = $nombre;

        return $this;
    }

    public function getDescripcion(): ?string
    {
        return $this->descripcion;
    }

    public function setDescripcion(string $descripcion): self
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    public function getFabricante()
    {
        return $this->fabricante;
    }

    public function setFabricante($fabricante): self
    {
        $this->fabricante = $fabricante;

        return $this;
    }

    public function getPrecio()
    {
        return $this->precio;
    }

    public function setPrecio($precio): self
    {
        $this->precio = $precio;

        return $this;
    }

    public function getMedidas()
    {
        return $this->medidas;
    }

    public function setMedidas($medidas): self
    {
        $this->medidas = $medidas;

        return $this;
    }

    public function getPdf()
    {
        return $this->pdf;
    }

    public function setPdf($pdf): self
    {
        $this->pdf = $pdf;

        return $this;
    }

    public function getActivo()
    {
        return $this->activo;
    }

    public function setActivo($activo): self
    {
        $this->activo = $activo;

        return $this;
    }
}
