<?php

namespace App\Entity;

use App\Repository\PedidoLineasRepository;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PedidoLineasRepository::class)
 */
class PedidoLineas
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="integer")
     */
    private $cantidad;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $referencia;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $color;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $descripcion;

    /**
     * @ORM\Column(type="float", nullable=true)
     */
    private $precioUnidad;

    /**
     * @ORM\Column(type="float", nullable=true)
     */
    private $precioTotal;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Pedidos", inversedBy="lineas")
     * @ORM\JoinColumn(nullable=true)
     */
    private $pedido;

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getCantidad(): ?int
    {
        return $this->cantidad;
    }

    public function setCantidad(int $cantidad): self
    {
        $this->cantidad = $cantidad;

        return $this;
    }

    public function getReferencia(): ?string
    {
        return $this->referencia;
    }

    public function setReferencia(string $referencia): self
    {
        $this->referencia = $referencia;

        return $this;
    }

    public function getColor(): ?string
    {
        return $this->color;
    }

    public function setColor(?string $color): self
    {
        $this->color = $color;

        return $this;
    }

    public function getDescripcion(): ?string
    {
        return $this->descripcion;
    }

    public function setDescripcion(?string $descripcion): self
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    public function getPrecioUnidad(): ?float
    {
        return $this->precioUnidad;
    }

    public function setPrecioUnidad(?float $precioUnidad): self
    {
        $this->precioUnidad = $precioUnidad;

        return $this;
    }

    public function getPrecioTotal(): ?float
    {
        return $this->precioTotal;
    }

    public function setPrecioTotal(?float $precioTotal): self
    {
        $this->precioTotal = $precioTotal;

        return $this;
    }

    public function getPedido()
    {
        return $this->pedido;
    }

    public function setPedido( $pedido)
    {
        $this->pedido = $pedido;

        return $this;
    }
}
