<?php

namespace Symfony\Config;

require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'SecurityConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'GlobalSearchConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'BreadcrumbsConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'OptionsConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'DashboardConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'DefaultAdminServicesConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'TemplatesConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'AssetsConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataAdmin'.\DIRECTORY_SEPARATOR.'ExtensionConfig.php';

use Symfony\Component\Config\Definition\Exception\InvalidConfigurationException;
use Symfony\Component\Config\Loader\ParamConfigurator;

/**
 * This class is automatically generated to help in creating a config.
 */
class SonataAdminConfig implements \Symfony\Component\Config\Builder\ConfigBuilderInterface
{
    private $security;
    private $title;
    private $titleLogo;
    private $search;
    private $globalSearch;
    private $defaultController;
    private $breadcrumbs;
    private $options;
    private $dashboard;
    private $defaultAdminServices;
    private $templates;
    private $assets;
    private $extensions;
    private $persistFilters;
    private $filterPersister;
    private $showMosaicButton;
    private $_usedProperties = [];

    public function security(array $value = []): \Symfony\Config\SonataAdmin\SecurityConfig
    {
        if (null === $this->security) {
            $this->_usedProperties['security'] = true;
            $this->security = new \Symfony\Config\SonataAdmin\SecurityConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "security()" has already been initialized. You cannot pass values the second time you call security().');
        }

        return $this->security;
    }

    /**
     * @default 'Sonata Admin'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function title($value): self
    {
        $this->_usedProperties['title'] = true;
        $this->title = $value;

        return $this;
    }

    /**
     * @default 'bundles/sonataadmin/images/logo_title.png'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function titleLogo($value): self
    {
        $this->_usedProperties['titleLogo'] = true;
        $this->titleLogo = $value;

        return $this;
    }

    /**
     * Enable/disable the search form in the sidebar
     * @default true
     * @param ParamConfigurator|bool $value
     * @return $this
     */
    public function search($value): self
    {
        $this->_usedProperties['search'] = true;
        $this->search = $value;

        return $this;
    }

    public function globalSearch(array $value = []): \Symfony\Config\SonataAdmin\GlobalSearchConfig
    {
        if (null === $this->globalSearch) {
            $this->_usedProperties['globalSearch'] = true;
            $this->globalSearch = new \Symfony\Config\SonataAdmin\GlobalSearchConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "globalSearch()" has already been initialized. You cannot pass values the second time you call globalSearch().');
        }

        return $this->globalSearch;
    }

    /**
     * Name of the controller class to be used as a default in admin definitions
     * @default 'sonata.admin.controller.crud'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function defaultController($value): self
    {
        $this->_usedProperties['defaultController'] = true;
        $this->defaultController = $value;

        return $this;
    }

    public function breadcrumbs(array $value = []): \Symfony\Config\SonataAdmin\BreadcrumbsConfig
    {
        if (null === $this->breadcrumbs) {
            $this->_usedProperties['breadcrumbs'] = true;
            $this->breadcrumbs = new \Symfony\Config\SonataAdmin\BreadcrumbsConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "breadcrumbs()" has already been initialized. You cannot pass values the second time you call breadcrumbs().');
        }

        return $this->breadcrumbs;
    }

    public function options(array $value = []): \Symfony\Config\SonataAdmin\OptionsConfig
    {
        if (null === $this->options) {
            $this->_usedProperties['options'] = true;
            $this->options = new \Symfony\Config\SonataAdmin\OptionsConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "options()" has already been initialized. You cannot pass values the second time you call options().');
        }

        return $this->options;
    }

    public function dashboard(array $value = []): \Symfony\Config\SonataAdmin\DashboardConfig
    {
        if (null === $this->dashboard) {
            $this->_usedProperties['dashboard'] = true;
            $this->dashboard = new \Symfony\Config\SonataAdmin\DashboardConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "dashboard()" has already been initialized. You cannot pass values the second time you call dashboard().');
        }

        return $this->dashboard;
    }

    public function defaultAdminServices(array $value = []): \Symfony\Config\SonataAdmin\DefaultAdminServicesConfig
    {
        if (null === $this->defaultAdminServices) {
            $this->_usedProperties['defaultAdminServices'] = true;
            $this->defaultAdminServices = new \Symfony\Config\SonataAdmin\DefaultAdminServicesConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "defaultAdminServices()" has already been initialized. You cannot pass values the second time you call defaultAdminServices().');
        }

        return $this->defaultAdminServices;
    }

    public function templates(array $value = []): \Symfony\Config\SonataAdmin\TemplatesConfig
    {
        if (null === $this->templates) {
            $this->_usedProperties['templates'] = true;
            $this->templates = new \Symfony\Config\SonataAdmin\TemplatesConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "templates()" has already been initialized. You cannot pass values the second time you call templates().');
        }

        return $this->templates;
    }

    public function assets(array $value = []): \Symfony\Config\SonataAdmin\AssetsConfig
    {
        if (null === $this->assets) {
            $this->_usedProperties['assets'] = true;
            $this->assets = new \Symfony\Config\SonataAdmin\AssetsConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "assets()" has already been initialized. You cannot pass values the second time you call assets().');
        }

        return $this->assets;
    }

    public function extension(string $id, array $value = []): \Symfony\Config\SonataAdmin\ExtensionConfig
    {
        if (!isset($this->extensions[$id])) {
            $this->_usedProperties['extensions'] = true;
            $this->extensions[$id] = new \Symfony\Config\SonataAdmin\ExtensionConfig($value);
        } elseif (1 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "extension()" has already been initialized. You cannot pass values the second time you call extension().');
        }

        return $this->extensions[$id];
    }

    /**
     * @default false
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function persistFilters($value): self
    {
        $this->_usedProperties['persistFilters'] = true;
        $this->persistFilters = $value;

        return $this;
    }

    /**
     * @default 'sonata.admin.filter_persister.session'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function filterPersister($value): self
    {
        $this->_usedProperties['filterPersister'] = true;
        $this->filterPersister = $value;

        return $this;
    }

    /**
     * Show mosaic button on all admin screens
     * @default true
     * @param ParamConfigurator|bool $value
     * @return $this
     */
    public function showMosaicButton($value): self
    {
        $this->_usedProperties['showMosaicButton'] = true;
        $this->showMosaicButton = $value;

        return $this;
    }

    public function getExtensionAlias(): string
    {
        return 'sonata_admin';
    }

    public function __construct(array $value = [])
    {
        if (array_key_exists('security', $value)) {
            $this->_usedProperties['security'] = true;
            $this->security = new \Symfony\Config\SonataAdmin\SecurityConfig($value['security']);
            unset($value['security']);
        }

        if (array_key_exists('title', $value)) {
            $this->_usedProperties['title'] = true;
            $this->title = $value['title'];
            unset($value['title']);
        }

        if (array_key_exists('title_logo', $value)) {
            $this->_usedProperties['titleLogo'] = true;
            $this->titleLogo = $value['title_logo'];
            unset($value['title_logo']);
        }

        if (array_key_exists('search', $value)) {
            $this->_usedProperties['search'] = true;
            $this->search = $value['search'];
            unset($value['search']);
        }

        if (array_key_exists('global_search', $value)) {
            $this->_usedProperties['globalSearch'] = true;
            $this->globalSearch = new \Symfony\Config\SonataAdmin\GlobalSearchConfig($value['global_search']);
            unset($value['global_search']);
        }

        if (array_key_exists('default_controller', $value)) {
            $this->_usedProperties['defaultController'] = true;
            $this->defaultController = $value['default_controller'];
            unset($value['default_controller']);
        }

        if (array_key_exists('breadcrumbs', $value)) {
            $this->_usedProperties['breadcrumbs'] = true;
            $this->breadcrumbs = new \Symfony\Config\SonataAdmin\BreadcrumbsConfig($value['breadcrumbs']);
            unset($value['breadcrumbs']);
        }

        if (array_key_exists('options', $value)) {
            $this->_usedProperties['options'] = true;
            $this->options = new \Symfony\Config\SonataAdmin\OptionsConfig($value['options']);
            unset($value['options']);
        }

        if (array_key_exists('dashboard', $value)) {
            $this->_usedProperties['dashboard'] = true;
            $this->dashboard = new \Symfony\Config\SonataAdmin\DashboardConfig($value['dashboard']);
            unset($value['dashboard']);
        }

        if (array_key_exists('default_admin_services', $value)) {
            $this->_usedProperties['defaultAdminServices'] = true;
            $this->defaultAdminServices = new \Symfony\Config\SonataAdmin\DefaultAdminServicesConfig($value['default_admin_services']);
            unset($value['default_admin_services']);
        }

        if (array_key_exists('templates', $value)) {
            $this->_usedProperties['templates'] = true;
            $this->templates = new \Symfony\Config\SonataAdmin\TemplatesConfig($value['templates']);
            unset($value['templates']);
        }

        if (array_key_exists('assets', $value)) {
            $this->_usedProperties['assets'] = true;
            $this->assets = new \Symfony\Config\SonataAdmin\AssetsConfig($value['assets']);
            unset($value['assets']);
        }

        if (array_key_exists('extensions', $value)) {
            $this->_usedProperties['extensions'] = true;
            $this->extensions = array_map(function ($v) { return new \Symfony\Config\SonataAdmin\ExtensionConfig($v); }, $value['extensions']);
            unset($value['extensions']);
        }

        if (array_key_exists('persist_filters', $value)) {
            $this->_usedProperties['persistFilters'] = true;
            $this->persistFilters = $value['persist_filters'];
            unset($value['persist_filters']);
        }

        if (array_key_exists('filter_persister', $value)) {
            $this->_usedProperties['filterPersister'] = true;
            $this->filterPersister = $value['filter_persister'];
            unset($value['filter_persister']);
        }

        if (array_key_exists('show_mosaic_button', $value)) {
            $this->_usedProperties['showMosaicButton'] = true;
            $this->showMosaicButton = $value['show_mosaic_button'];
            unset($value['show_mosaic_button']);
        }

        if ([] !== $value) {
            throw new InvalidConfigurationException(sprintf('The following keys are not supported by "%s": ', __CLASS__).implode(', ', array_keys($value)));
        }
    }

    public function toArray(): array
    {
        $output = [];
        if (isset($this->_usedProperties['security'])) {
            $output['security'] = $this->security->toArray();
        }
        if (isset($this->_usedProperties['title'])) {
            $output['title'] = $this->title;
        }
        if (isset($this->_usedProperties['titleLogo'])) {
            $output['title_logo'] = $this->titleLogo;
        }
        if (isset($this->_usedProperties['search'])) {
            $output['search'] = $this->search;
        }
        if (isset($this->_usedProperties['globalSearch'])) {
            $output['global_search'] = $this->globalSearch->toArray();
        }
        if (isset($this->_usedProperties['defaultController'])) {
            $output['default_controller'] = $this->defaultController;
        }
        if (isset($this->_usedProperties['breadcrumbs'])) {
            $output['breadcrumbs'] = $this->breadcrumbs->toArray();
        }
        if (isset($this->_usedProperties['options'])) {
            $output['options'] = $this->options->toArray();
        }
        if (isset($this->_usedProperties['dashboard'])) {
            $output['dashboard'] = $this->dashboard->toArray();
        }
        if (isset($this->_usedProperties['defaultAdminServices'])) {
            $output['default_admin_services'] = $this->defaultAdminServices->toArray();
        }
        if (isset($this->_usedProperties['templates'])) {
            $output['templates'] = $this->templates->toArray();
        }
        if (isset($this->_usedProperties['assets'])) {
            $output['assets'] = $this->assets->toArray();
        }
        if (isset($this->_usedProperties['extensions'])) {
            $output['extensions'] = array_map(function ($v) { return $v->toArray(); }, $this->extensions);
        }
        if (isset($this->_usedProperties['persistFilters'])) {
            $output['persist_filters'] = $this->persistFilters;
        }
        if (isset($this->_usedProperties['filterPersister'])) {
            $output['filter_persister'] = $this->filterPersister;
        }
        if (isset($this->_usedProperties['showMosaicButton'])) {
            $output['show_mosaic_button'] = $this->showMosaicButton;
        }

        return $output;
    }

}
