<?php

namespace Symfony\Config\SonataMedia;

use Symfony\Component\Config\Loader\ParamConfigurator;
use Symfony\Component\Config\Definition\Exception\InvalidConfigurationException;

/**
 * This class is automatically generated to help in creating a config.
 */
class ClassConfig 
{
    private $media;
    private $gallery;
    private $galleryItem;
    private $category;
    private $_usedProperties = [];

    /**
     * @default 'App\\Entity\\SonataMediaMedia'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function media($value): self
    {
        $this->_usedProperties['media'] = true;
        $this->media = $value;

        return $this;
    }

    /**
     * @default 'App\\Entity\\SonataMediaGallery'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function gallery($value): self
    {
        $this->_usedProperties['gallery'] = true;
        $this->gallery = $value;

        return $this;
    }

    /**
     * @default 'App\\Entity\\SonataMediaGalleryItem'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function galleryItem($value): self
    {
        $this->_usedProperties['galleryItem'] = true;
        $this->galleryItem = $value;

        return $this;
    }

    /**
     * @default 'App\\Entity\\SonataClassificationCategory'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function category($value): self
    {
        $this->_usedProperties['category'] = true;
        $this->category = $value;

        return $this;
    }

    public function __construct(array $value = [])
    {
        if (array_key_exists('media', $value)) {
            $this->_usedProperties['media'] = true;
            $this->media = $value['media'];
            unset($value['media']);
        }

        if (array_key_exists('gallery', $value)) {
            $this->_usedProperties['gallery'] = true;
            $this->gallery = $value['gallery'];
            unset($value['gallery']);
        }

        if (array_key_exists('gallery_item', $value)) {
            $this->_usedProperties['galleryItem'] = true;
            $this->galleryItem = $value['gallery_item'];
            unset($value['gallery_item']);
        }

        if (array_key_exists('category', $value)) {
            $this->_usedProperties['category'] = true;
            $this->category = $value['category'];
            unset($value['category']);
        }

        if ([] !== $value) {
            throw new InvalidConfigurationException(sprintf('The following keys are not supported by "%s": ', __CLASS__).implode(', ', array_keys($value)));
        }
    }

    public function toArray(): array
    {
        $output = [];
        if (isset($this->_usedProperties['media'])) {
            $output['media'] = $this->media;
        }
        if (isset($this->_usedProperties['gallery'])) {
            $output['gallery'] = $this->gallery;
        }
        if (isset($this->_usedProperties['galleryItem'])) {
            $output['gallery_item'] = $this->galleryItem;
        }
        if (isset($this->_usedProperties['category'])) {
            $output['category'] = $this->category;
        }

        return $output;
    }

}
