<?php

namespace Symfony\Config\SonataMedia\Providers;

use Symfony\Component\Config\Loader\ParamConfigurator;
use Symfony\Component\Config\Definition\Exception\InvalidConfigurationException;

/**
 * This class is automatically generated to help in creating a config.
 */
class VimeoConfig 
{
    private $service;
    private $resizer;
    private $filesystem;
    private $cdn;
    private $generator;
    private $thumbnail;
    private $_usedProperties = [];

    /**
     * @default 'sonata.media.provider.vimeo'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function service($value): self
    {
        $this->_usedProperties['service'] = true;
        $this->service = $value;

        return $this;
    }

    /**
     * @default 'sonata.media.resizer.default'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function resizer($value): self
    {
        $this->_usedProperties['resizer'] = true;
        $this->resizer = $value;

        return $this;
    }

    /**
     * @default 'sonata.media.filesystem.local'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function filesystem($value): self
    {
        $this->_usedProperties['filesystem'] = true;
        $this->filesystem = $value;

        return $this;
    }

    /**
     * @default 'sonata.media.cdn.server'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function cdn($value): self
    {
        $this->_usedProperties['cdn'] = true;
        $this->cdn = $value;

        return $this;
    }

    /**
     * @default 'sonata.media.generator.default'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function generator($value): self
    {
        $this->_usedProperties['generator'] = true;
        $this->generator = $value;

        return $this;
    }

    /**
     * @default 'sonata.media.thumbnail.format'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function thumbnail($value): self
    {
        $this->_usedProperties['thumbnail'] = true;
        $this->thumbnail = $value;

        return $this;
    }

    public function __construct(array $value = [])
    {
        if (array_key_exists('service', $value)) {
            $this->_usedProperties['service'] = true;
            $this->service = $value['service'];
            unset($value['service']);
        }

        if (array_key_exists('resizer', $value)) {
            $this->_usedProperties['resizer'] = true;
            $this->resizer = $value['resizer'];
            unset($value['resizer']);
        }

        if (array_key_exists('filesystem', $value)) {
            $this->_usedProperties['filesystem'] = true;
            $this->filesystem = $value['filesystem'];
            unset($value['filesystem']);
        }

        if (array_key_exists('cdn', $value)) {
            $this->_usedProperties['cdn'] = true;
            $this->cdn = $value['cdn'];
            unset($value['cdn']);
        }

        if (array_key_exists('generator', $value)) {
            $this->_usedProperties['generator'] = true;
            $this->generator = $value['generator'];
            unset($value['generator']);
        }

        if (array_key_exists('thumbnail', $value)) {
            $this->_usedProperties['thumbnail'] = true;
            $this->thumbnail = $value['thumbnail'];
            unset($value['thumbnail']);
        }

        if ([] !== $value) {
            throw new InvalidConfigurationException(sprintf('The following keys are not supported by "%s": ', __CLASS__).implode(', ', array_keys($value)));
        }
    }

    public function toArray(): array
    {
        $output = [];
        if (isset($this->_usedProperties['service'])) {
            $output['service'] = $this->service;
        }
        if (isset($this->_usedProperties['resizer'])) {
            $output['resizer'] = $this->resizer;
        }
        if (isset($this->_usedProperties['filesystem'])) {
            $output['filesystem'] = $this->filesystem;
        }
        if (isset($this->_usedProperties['cdn'])) {
            $output['cdn'] = $this->cdn;
        }
        if (isset($this->_usedProperties['generator'])) {
            $output['generator'] = $this->generator;
        }
        if (isset($this->_usedProperties['thumbnail'])) {
            $output['thumbnail'] = $this->thumbnail;
        }

        return $output;
    }

}
