<?php

namespace Symfony\Config\SonataMedia;

require_once __DIR__.\DIRECTORY_SEPARATOR.'Providers'.\DIRECTORY_SEPARATOR.'FileConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'Providers'.\DIRECTORY_SEPARATOR.'ImageConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'Providers'.\DIRECTORY_SEPARATOR.'YoutubeConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'Providers'.\DIRECTORY_SEPARATOR.'DailymotionConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'Providers'.\DIRECTORY_SEPARATOR.'VimeoConfig.php';

use Symfony\Component\Config\Definition\Exception\InvalidConfigurationException;

/**
 * This class is automatically generated to help in creating a config.
 */
class ProvidersConfig 
{
    private $file;
    private $image;
    private $youtube;
    private $dailymotion;
    private $vimeo;
    private $_usedProperties = [];

    public function file(array $value = []): \Symfony\Config\SonataMedia\Providers\FileConfig
    {
        if (null === $this->file) {
            $this->_usedProperties['file'] = true;
            $this->file = new \Symfony\Config\SonataMedia\Providers\FileConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "file()" has already been initialized. You cannot pass values the second time you call file().');
        }

        return $this->file;
    }

    public function image(array $value = []): \Symfony\Config\SonataMedia\Providers\ImageConfig
    {
        if (null === $this->image) {
            $this->_usedProperties['image'] = true;
            $this->image = new \Symfony\Config\SonataMedia\Providers\ImageConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "image()" has already been initialized. You cannot pass values the second time you call image().');
        }

        return $this->image;
    }

    public function youtube(array $value = []): \Symfony\Config\SonataMedia\Providers\YoutubeConfig
    {
        if (null === $this->youtube) {
            $this->_usedProperties['youtube'] = true;
            $this->youtube = new \Symfony\Config\SonataMedia\Providers\YoutubeConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "youtube()" has already been initialized. You cannot pass values the second time you call youtube().');
        }

        return $this->youtube;
    }

    public function dailymotion(array $value = []): \Symfony\Config\SonataMedia\Providers\DailymotionConfig
    {
        if (null === $this->dailymotion) {
            $this->_usedProperties['dailymotion'] = true;
            $this->dailymotion = new \Symfony\Config\SonataMedia\Providers\DailymotionConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "dailymotion()" has already been initialized. You cannot pass values the second time you call dailymotion().');
        }

        return $this->dailymotion;
    }

    public function vimeo(array $value = []): \Symfony\Config\SonataMedia\Providers\VimeoConfig
    {
        if (null === $this->vimeo) {
            $this->_usedProperties['vimeo'] = true;
            $this->vimeo = new \Symfony\Config\SonataMedia\Providers\VimeoConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "vimeo()" has already been initialized. You cannot pass values the second time you call vimeo().');
        }

        return $this->vimeo;
    }

    public function __construct(array $value = [])
    {
        if (array_key_exists('file', $value)) {
            $this->_usedProperties['file'] = true;
            $this->file = new \Symfony\Config\SonataMedia\Providers\FileConfig($value['file']);
            unset($value['file']);
        }

        if (array_key_exists('image', $value)) {
            $this->_usedProperties['image'] = true;
            $this->image = new \Symfony\Config\SonataMedia\Providers\ImageConfig($value['image']);
            unset($value['image']);
        }

        if (array_key_exists('youtube', $value)) {
            $this->_usedProperties['youtube'] = true;
            $this->youtube = new \Symfony\Config\SonataMedia\Providers\YoutubeConfig($value['youtube']);
            unset($value['youtube']);
        }

        if (array_key_exists('dailymotion', $value)) {
            $this->_usedProperties['dailymotion'] = true;
            $this->dailymotion = new \Symfony\Config\SonataMedia\Providers\DailymotionConfig($value['dailymotion']);
            unset($value['dailymotion']);
        }

        if (array_key_exists('vimeo', $value)) {
            $this->_usedProperties['vimeo'] = true;
            $this->vimeo = new \Symfony\Config\SonataMedia\Providers\VimeoConfig($value['vimeo']);
            unset($value['vimeo']);
        }

        if ([] !== $value) {
            throw new InvalidConfigurationException(sprintf('The following keys are not supported by "%s": ', __CLASS__).implode(', ', array_keys($value)));
        }
    }

    public function toArray(): array
    {
        $output = [];
        if (isset($this->_usedProperties['file'])) {
            $output['file'] = $this->file->toArray();
        }
        if (isset($this->_usedProperties['image'])) {
            $output['image'] = $this->image->toArray();
        }
        if (isset($this->_usedProperties['youtube'])) {
            $output['youtube'] = $this->youtube->toArray();
        }
        if (isset($this->_usedProperties['dailymotion'])) {
            $output['dailymotion'] = $this->dailymotion->toArray();
        }
        if (isset($this->_usedProperties['vimeo'])) {
            $output['vimeo'] = $this->vimeo->toArray();
        }

        return $output;
    }

}
