<?php

namespace Symfony\Config;

require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'AdminFormatConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'ContextsConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'CdnConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'FilesystemConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'ProvidersConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'ClassConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'HttpConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'ResizerConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'ResizersConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'AdaptersConfig.php';
require_once __DIR__.\DIRECTORY_SEPARATOR.'SonataMedia'.\DIRECTORY_SEPARATOR.'MessengerConfig.php';

use Symfony\Component\Config\Loader\ParamConfigurator;
use Symfony\Component\Config\Definition\Exception\InvalidConfigurationException;

/**
 * This class is automatically generated to help in creating a config.
 */
class SonataMediaConfig implements \Symfony\Component\Config\Builder\ConfigBuilderInterface
{
    private $dbDriver;
    private $defaultContext;
    private $forceDisableCategory;
    private $adminFormat;
    private $contexts;
    private $cdn;
    private $filesystem;
    private $providers;
    private $class;
    private $http;
    private $resizer;
    private $resizers;
    private $adapters;
    private $messenger;
    private $_usedProperties = [];

    /**
     * Choose persistence mechanism driver from the following list: "doctrine_orm", "doctrine_mongodb"
     * @default 'no_driver'
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function dbDriver($value): self
    {
        $this->_usedProperties['dbDriver'] = true;
        $this->dbDriver = $value;

        return $this;
    }

    /**
     * @default null
     * @param ParamConfigurator|mixed $value
     * @return $this
     */
    public function defaultContext($value): self
    {
        $this->_usedProperties['defaultContext'] = true;
        $this->defaultContext = $value;

        return $this;
    }

    /**
     * true IF you really want to disable the relation with category
     * @default false
     * @param ParamConfigurator|bool $value
     * @return $this
     */
    public function forceDisableCategory($value): self
    {
        $this->_usedProperties['forceDisableCategory'] = true;
        $this->forceDisableCategory = $value;

        return $this;
    }

    public function adminFormat(array $value = []): \Symfony\Config\SonataMedia\AdminFormatConfig
    {
        if (null === $this->adminFormat) {
            $this->_usedProperties['adminFormat'] = true;
            $this->adminFormat = new \Symfony\Config\SonataMedia\AdminFormatConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "adminFormat()" has already been initialized. You cannot pass values the second time you call adminFormat().');
        }

        return $this->adminFormat;
    }

    public function contexts(string $id, array $value = []): \Symfony\Config\SonataMedia\ContextsConfig
    {
        if (!isset($this->contexts[$id])) {
            $this->_usedProperties['contexts'] = true;
            $this->contexts[$id] = new \Symfony\Config\SonataMedia\ContextsConfig($value);
        } elseif (1 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "contexts()" has already been initialized. You cannot pass values the second time you call contexts().');
        }

        return $this->contexts[$id];
    }

    public function cdn(array $value = []): \Symfony\Config\SonataMedia\CdnConfig
    {
        if (null === $this->cdn) {
            $this->_usedProperties['cdn'] = true;
            $this->cdn = new \Symfony\Config\SonataMedia\CdnConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "cdn()" has already been initialized. You cannot pass values the second time you call cdn().');
        }

        return $this->cdn;
    }

    public function filesystem(array $value = []): \Symfony\Config\SonataMedia\FilesystemConfig
    {
        if (null === $this->filesystem) {
            $this->_usedProperties['filesystem'] = true;
            $this->filesystem = new \Symfony\Config\SonataMedia\FilesystemConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "filesystem()" has already been initialized. You cannot pass values the second time you call filesystem().');
        }

        return $this->filesystem;
    }

    public function providers(array $value = []): \Symfony\Config\SonataMedia\ProvidersConfig
    {
        if (null === $this->providers) {
            $this->_usedProperties['providers'] = true;
            $this->providers = new \Symfony\Config\SonataMedia\ProvidersConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "providers()" has already been initialized. You cannot pass values the second time you call providers().');
        }

        return $this->providers;
    }

    public function class(array $value = []): \Symfony\Config\SonataMedia\ClassConfig
    {
        if (null === $this->class) {
            $this->_usedProperties['class'] = true;
            $this->class = new \Symfony\Config\SonataMedia\ClassConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "class()" has already been initialized. You cannot pass values the second time you call class().');
        }

        return $this->class;
    }

    public function http(array $value = []): \Symfony\Config\SonataMedia\HttpConfig
    {
        if (null === $this->http) {
            $this->_usedProperties['http'] = true;
            $this->http = new \Symfony\Config\SonataMedia\HttpConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "http()" has already been initialized. You cannot pass values the second time you call http().');
        }

        return $this->http;
    }

    public function resizer(array $value = []): \Symfony\Config\SonataMedia\ResizerConfig
    {
        if (null === $this->resizer) {
            $this->_usedProperties['resizer'] = true;
            $this->resizer = new \Symfony\Config\SonataMedia\ResizerConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "resizer()" has already been initialized. You cannot pass values the second time you call resizer().');
        }

        return $this->resizer;
    }

    public function resizers(array $value = []): \Symfony\Config\SonataMedia\ResizersConfig
    {
        if (null === $this->resizers) {
            $this->_usedProperties['resizers'] = true;
            $this->resizers = new \Symfony\Config\SonataMedia\ResizersConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "resizers()" has already been initialized. You cannot pass values the second time you call resizers().');
        }

        return $this->resizers;
    }

    public function adapters(array $value = []): \Symfony\Config\SonataMedia\AdaptersConfig
    {
        if (null === $this->adapters) {
            $this->_usedProperties['adapters'] = true;
            $this->adapters = new \Symfony\Config\SonataMedia\AdaptersConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "adapters()" has already been initialized. You cannot pass values the second time you call adapters().');
        }

        return $this->adapters;
    }

    /**
     * @return \Symfony\Config\SonataMedia\MessengerConfig|$this
     */
    public function messenger($value = [])
    {
        if (!\is_array($value)) {
            $this->_usedProperties['messenger'] = true;
            $this->messenger = $value;

            return $this;
        }

        if (!$this->messenger instanceof \Symfony\Config\SonataMedia\MessengerConfig) {
            $this->_usedProperties['messenger'] = true;
            $this->messenger = new \Symfony\Config\SonataMedia\MessengerConfig($value);
        } elseif (0 < \func_num_args()) {
            throw new InvalidConfigurationException('The node created by "messenger()" has already been initialized. You cannot pass values the second time you call messenger().');
        }

        return $this->messenger;
    }

    public function getExtensionAlias(): string
    {
        return 'sonata_media';
    }

    public function __construct(array $value = [])
    {
        if (array_key_exists('db_driver', $value)) {
            $this->_usedProperties['dbDriver'] = true;
            $this->dbDriver = $value['db_driver'];
            unset($value['db_driver']);
        }

        if (array_key_exists('default_context', $value)) {
            $this->_usedProperties['defaultContext'] = true;
            $this->defaultContext = $value['default_context'];
            unset($value['default_context']);
        }

        if (array_key_exists('force_disable_category', $value)) {
            $this->_usedProperties['forceDisableCategory'] = true;
            $this->forceDisableCategory = $value['force_disable_category'];
            unset($value['force_disable_category']);
        }

        if (array_key_exists('admin_format', $value)) {
            $this->_usedProperties['adminFormat'] = true;
            $this->adminFormat = new \Symfony\Config\SonataMedia\AdminFormatConfig($value['admin_format']);
            unset($value['admin_format']);
        }

        if (array_key_exists('contexts', $value)) {
            $this->_usedProperties['contexts'] = true;
            $this->contexts = array_map(function ($v) { return new \Symfony\Config\SonataMedia\ContextsConfig($v); }, $value['contexts']);
            unset($value['contexts']);
        }

        if (array_key_exists('cdn', $value)) {
            $this->_usedProperties['cdn'] = true;
            $this->cdn = new \Symfony\Config\SonataMedia\CdnConfig($value['cdn']);
            unset($value['cdn']);
        }

        if (array_key_exists('filesystem', $value)) {
            $this->_usedProperties['filesystem'] = true;
            $this->filesystem = new \Symfony\Config\SonataMedia\FilesystemConfig($value['filesystem']);
            unset($value['filesystem']);
        }

        if (array_key_exists('providers', $value)) {
            $this->_usedProperties['providers'] = true;
            $this->providers = new \Symfony\Config\SonataMedia\ProvidersConfig($value['providers']);
            unset($value['providers']);
        }

        if (array_key_exists('class', $value)) {
            $this->_usedProperties['class'] = true;
            $this->class = new \Symfony\Config\SonataMedia\ClassConfig($value['class']);
            unset($value['class']);
        }

        if (array_key_exists('http', $value)) {
            $this->_usedProperties['http'] = true;
            $this->http = new \Symfony\Config\SonataMedia\HttpConfig($value['http']);
            unset($value['http']);
        }

        if (array_key_exists('resizer', $value)) {
            $this->_usedProperties['resizer'] = true;
            $this->resizer = new \Symfony\Config\SonataMedia\ResizerConfig($value['resizer']);
            unset($value['resizer']);
        }

        if (array_key_exists('resizers', $value)) {
            $this->_usedProperties['resizers'] = true;
            $this->resizers = new \Symfony\Config\SonataMedia\ResizersConfig($value['resizers']);
            unset($value['resizers']);
        }

        if (array_key_exists('adapters', $value)) {
            $this->_usedProperties['adapters'] = true;
            $this->adapters = new \Symfony\Config\SonataMedia\AdaptersConfig($value['adapters']);
            unset($value['adapters']);
        }

        if (array_key_exists('messenger', $value)) {
            $this->_usedProperties['messenger'] = true;
            $this->messenger = \is_array($value['messenger']) ? new \Symfony\Config\SonataMedia\MessengerConfig($value['messenger']) : $value['messenger'];
            unset($value['messenger']);
        }

        if ([] !== $value) {
            throw new InvalidConfigurationException(sprintf('The following keys are not supported by "%s": ', __CLASS__).implode(', ', array_keys($value)));
        }
    }

    public function toArray(): array
    {
        $output = [];
        if (isset($this->_usedProperties['dbDriver'])) {
            $output['db_driver'] = $this->dbDriver;
        }
        if (isset($this->_usedProperties['defaultContext'])) {
            $output['default_context'] = $this->defaultContext;
        }
        if (isset($this->_usedProperties['forceDisableCategory'])) {
            $output['force_disable_category'] = $this->forceDisableCategory;
        }
        if (isset($this->_usedProperties['adminFormat'])) {
            $output['admin_format'] = $this->adminFormat->toArray();
        }
        if (isset($this->_usedProperties['contexts'])) {
            $output['contexts'] = array_map(function ($v) { return $v->toArray(); }, $this->contexts);
        }
        if (isset($this->_usedProperties['cdn'])) {
            $output['cdn'] = $this->cdn->toArray();
        }
        if (isset($this->_usedProperties['filesystem'])) {
            $output['filesystem'] = $this->filesystem->toArray();
        }
        if (isset($this->_usedProperties['providers'])) {
            $output['providers'] = $this->providers->toArray();
        }
        if (isset($this->_usedProperties['class'])) {
            $output['class'] = $this->class->toArray();
        }
        if (isset($this->_usedProperties['http'])) {
            $output['http'] = $this->http->toArray();
        }
        if (isset($this->_usedProperties['resizer'])) {
            $output['resizer'] = $this->resizer->toArray();
        }
        if (isset($this->_usedProperties['resizers'])) {
            $output['resizers'] = $this->resizers->toArray();
        }
        if (isset($this->_usedProperties['adapters'])) {
            $output['adapters'] = $this->adapters->toArray();
        }
        if (isset($this->_usedProperties['messenger'])) {
            $output['messenger'] = $this->messenger instanceof \Symfony\Config\SonataMedia\MessengerConfig ? $this->messenger->toArray() : $this->messenger;
        }

        return $output;
    }

}
